//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>

void xr_add(XREAL *num1,XREAL *num2,XREAL *result)
{
XREAL *tmp;


	// HANDLE SPECIAL NUMBERS
	if(num1->Exp==(1<<29)) {
	if(num1->Mant) {
	// +/- INF
	// +/-INF + NUMBER = +/-INF
	result->Mant=num1->Mant;
	result->Exp=num1->Exp;
	result->Sign=num1->Sign;
	return;	
	}
	else {
	// +/- NAN
	result->Mant=0;
	result->Exp=(1<<29);
	result->Sign=num1->Sign;
	return;	
	}
	
	}


	if(num2->Exp==(1<<29)) {
	if(num2->Mant) {
	// +/- INF
	// +/-INF + NUMBER = +/-INF
	result->Mant=num2->Mant;
	result->Exp=num2->Exp;
	result->Sign=num2->Sign;
	return;	
	}
	else {
	// +/- NAN
	result->Mant=0;
	result->Exp=(1<<29);
	result->Sign=num2->Sign;
	return;	
	}
	
	}



	if( (num2->Exp>num1->Exp) || ((num2->Exp==num1->Exp)&&(num2->Mant>num1->Mant))){
	
	// ENSURE NUM1 IS THE LARGEST NUMBER
		tmp=num1;
		num1=num2;
		num2=tmp;
	}

	int rot=num1->Exp-num2->Exp;
	
	if(rot>63) {
		// INSIGNIFICANT SMALL NUMBER
		result->Exp=num1->Exp;
		result->Mant=num1->Mant;
		result->Sign=num1->Sign;
		return;
	}
	
	// ROUND SMALL MANTISSA AND DISCARD BITS
	
	ULONGLONG rotmant=1<<(63-rot);
	rotmant=(num2->Mant+rotmant)>>rot;
	
	result->Exp=num1->Exp;
	
	if(num1->Sign==num2->Sign) {
	rotmant=num1->Mant+rotmant;
	// CHECK FOR CARRY
	if(rotmant<num1->Mant) { result->Mant=((rotmant+1)>>1)|0x8000000000000000LL; result->Exp++; }
	else { result->Mant=rotmant; }
	}
	else {
	result->Mant=num1->Mant-rotmant;

	if(result->Mant!=0) {
	// NOT CARRY IS GUARANTEED BY num1>num2
	// NORMALIZE RESULT IF PARTIAL PRECISION LOSS
		while(!(result->Mant&0x8000000000000000LL))
		{
		result->Mant<<=1;
		result->Exp--;
		}
		
	}
	else {
		// MANTISSA = 0 MEANS THE RESULT IS ZERO, NOTMALIZE EXPONENT:
		result->Exp=-63;
		result->Sign=0;
		return;
	}
	}

	result->Sign=num1->Sign;
return;
}
