//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***





// $Id: sat3_alloc.c 393 2007-03-04 23:17:29Z ingo $


#include <hpgcc3.h>
#include <master_globals.h>
#include <stdarg.h>


#define SAT_BINT0 0x33107
#define SAT_LASTROMWDOB 0x80829
#define SAT_DEPTHSAVE 0x80edc
#define SAT_LASTARGCOUNT 0x80f5a
#define SAT_LASTARG1 0x80775



BOOL sat3_isptr(SAT_OBJECT obj)
{
	SAT_OBJECT ptr;
	if(!obj) return FALSE;
	ptr=sat3_peek(obj,5);
	
	return ((ptr>0x2fef)&&(ptr<0x3ffff))? TRUE:FALSE;
}

BOOL sat3_checktype(SAT_OBJECT obj,unsigned int prolog)
{
if(!obj) return FALSE;	
if(prolog==SAT_ANY) return TRUE;

if(sat3_isptr(obj)) obj=sat3_peek(obj,5);

if(prolog&SAT_OPTIONAL_TAG) {
	if(sat3_peek(obj,5)==SAT_DOTAG) obj=sat3_striptag(obj);
	prolog&=~(SAT_TAGGED | SAT_OPTIONAL_TAG);
}
if(prolog&SAT_TAGGED) {
	if(sat3_peek(obj,5)!=SAT_DOTAG) return FALSE;
	obj=sat3_striptag(obj);
	prolog&=~(SAT_TAGGED | SAT_OPTIONAL_TAG);
}

if(prolog==SAT_NUMERIC) {

	switch(sat3_peek(obj,5))
	{
	case SAT_DOBINT:
	case SAT_DOREAL:
	case SAT_DOINT:
	case SAT_DOHXS:
	return TRUE;
	default:
	return FALSE;
	}
}

if(sat3_peek(obj,5)==prolog) return TRUE;
return FALSE;		
}


BOOL sat3_checkargs(int n,...)
{
va_list argp;
int count;

if(sat3_depth()<n) return FALSE;

va_start(argp,n);

for(count=1;count<=n;++count)
{
if(!sat3_checktype(sat3_pick(count),va_arg(argp,unsigned int))) return FALSE;
}

va_end(argp);

return TRUE;	
}
	
// DOES 0LASTOWDOB! AND 0LastRomWrd!
BOOL sat3_ckn(int n)
{
sat3_poke(SAT_LASTROMWDOB,SAT_BINT0,5);		// 0LastRomWrd!
	
if(sat3_depth()<n) {
	sat3_poke(SAT_DEPTHSAVE,(sat3_depth()+1)*5,5);
	sat3_poke(SAT_LASTARGCOUNT,0,1);
	return FALSE;	// TOO FEW ARGUMENTS
}
if(n>5) n=5;
sat3_poke(SAT_DEPTHSAVE,(sat3_depth()-n+1)*5,5);
sat3_poke(SAT_LASTARGCOUNT,(sat3_peek(SAT_LASTARGCOUNT,2)&(~0x10))| n,2);
sat3_memmove(SAT_LASTARG1,sat3_peek(SAT_DSKTOP,5),5*n);
return TRUE;	
}	


void sat3_cknerror(int n)
{
	if(!sat3_ckn(n)) sat3_exiterror(SATERR_TOOFEWARGS);
}

void sat3_checkargserror(int n,...)
{
va_list argp;
int count;

if(sat3_depth()<n) sat3_exiterror(SATERR_TOOFEWARGS);

va_start(argp,n);

for(count=1;count<=n;++count)
{
if(!sat3_checktype(sat3_pick(count),va_arg(argp,unsigned int))) sat3_exiterror(SATERR_BADARGTYPE);
}

va_end(argp);

return;	
}
