//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_s2a.c 394 2007-03-05 03:40:13Z ingo $

#include <hpgcc3.h>
#include <master_globals.h>



// sat_addr CAN BE: 1) SATURN VISIBLE ADDRESS OR 2) (BANK&0xff)<<20 + ADDRESS
// WHERE BANK= 0-15 --> FLASH, -1 = MAIN RAM, -2=ERAM AS RETURNED BY __launch_getbanknum()
/* SAT_OBJECT is a generic address container. This address can be a Saturn
 * pointer or a C-heap pointer, with one of the following formats:
 *
 *     0x000AAAAA     20-bit Saturn address
 *     0x2FFAAAAA     20-bit Saturn address (AAAAA) + Flash bank number (FF)
 *     0x4HHHHHHH     29-bit ARM domain address, shifted left to accomodate 1 extra bit for
 *                    nibble-alignment 
 *     0x5HHHHHHH     29-bit ARM physical ram address, shifted left to accomodate 1 extra bit for
 *                    nibble-alignment 
 *
*/

unsigned int sat3_s2a(SAT_OBJECT sat_addr)
{
register int a=sat_addr>>28;

if(a&2) { 		// ADDRESS HAS EMBEDDED BANK INFORMATION?
						if(sat_addr&0X0F000000) // BANK IS IN RAM?
							return (((sat_addr&0xfffff)>>1)+0x08000000);	// FOR RAM: ARM=SATURN>>1 + 0X08000000
						else
							return ((sat_addr&0xfffff)>>1)+((sat_addr&0x0ff00000)>>3)+0x20000;  // FOR FLASH: ARM=SATURN>>1 + (BANK+1)*0x20000
						}
if(a&4) return (sat_addr>>1)&0x0fffffff;		// ADDRESS IS ALREADY ARM, RETURN UNCHANGED

if(a==0) // USE VISIBLE SATURN ADDRESSES
		return __mg->_saturn_cpu->Read[sat_addr >> 12] + (sat_addr & 0xfff)/2;
// INVALID OBJECT OTHERWISE
return 0xffffffff;
}
