//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <keyb.h>
#include <stdio.h>
#include <conio.h>
#include <kos.h>
#include <string.h>
#include <master_globals.h>


// CONVERTED FROM putcon.s
// ORIGINAL WORK BY Ingo Blank

#define _TAB_SIZE 4

// GENERAL INTERNAL FUNCTIONS

int get_decimal_digits() { return __mg->__console_vars->__decimal_digits; }
void set_decimal_digits(int v) { __mg->__console_vars->__decimal_digits=v; }
char *get_decimal_separator() { return __mg->__console_vars->__decimal_separator; }
void set_decimal_separator(char a) { *__mg->__console_vars->__decimal_separator=a; }



extern void memsetw(void *dest,int value, int nwords);
extern void memcpyw(void *dest,const void *source,int nwords);

void clear_screen_orig()
{
    memsetw((void *)__mg->__console_vars->__display_buf,0,5*lcd_getheight());
    // it's assumed, that the programmer also wants to set the cursor at home
    // < ibl ; 2004-10-28 >
    gotoxy_orig(0,0);
}



void scroll()
{

    int nwords=5*lcd_getheight();
    // AREN'T WE SCROLLING THE ANNUNCIATORS TOO WHEN DOING THIS?

    //memcpyw((void *)__mg->__display_buf,(void *)(__mg->__display_buf+__mg->__ch_h+(__mg->__ch_h<<2)),400-__mg->__ch_h-(__mg->__ch_h<<2));
    
    // nb of words per line: 5
    // nb of lines to scroll: __mg->__ch_h
    // -> nb of words to skip = 5*__mg->__ch_h = __mg->__ch_h<<2+__mg->__ch_h
    memcpyw((void *)__mg->__console_vars->__display_buf,
        (void *)((int *)__mg->__console_vars->__display_buf+(__mg->__console_vars->__ch_h+(__mg->__console_vars->__ch_h<<2))),
        nwords-__mg->__console_vars->__ch_h-(__mg->__console_vars->__ch_h<<2));

    // smooth option not supported
    
    memsetw((void *) ((int *)(__mg->__console_vars->__display_buf+nwords*4)-(__mg->__console_vars->__ch_h+(__mg->__console_vars->__ch_h<<2))),0,__mg->__console_vars->__ch_h+(__mg->__console_vars->__ch_h<<2));

}


void putcon(c)
{
void *minif=get_minifont();

int cdatalow,cdatahigh;
int offset,rot,rotx;
char *scrptr=(char *)__mg->__console_vars->__display_buf;
char mask;
int f;

// POINT TO START OF LINE
scrptr+=__mg->__console_vars->__pos_y*__mg->__console_vars->__ch_h*20;
scrptr+=__mg->__console_vars->__pos_x>>1;
rotx=__mg->__console_vars->__pos_x&1;
mask=(rotx)? 0xf0:0x0f;

// CALC OFFSET IN NIBBLES
offset=c*__mg->__console_vars->__ch_h+7;
// OFFSET IN NIBBLES
rot=offset&7;
// WORD WITH THE START OF CHAR
offset&=0xfffffff8;
// READ THE DATA CHARACTER
cdatalow=*(int *)(minif+(offset>>1));
cdatahigh=*(int *)(minif+4+(offset>>1));

// PUT DATA IN POSITION
while(rot<rotx)
{
cdatahigh= (cdatahigh<<4) | (cdatalow>>28);
cdatalow<<=4;

++rot;
}

while(rot>rotx) {
cdatalow= (cdatalow>>4) | (cdatahigh<<28);
cdatahigh>>=4;
--rot;
}

for(f=0;f<__mg->__console_vars->__ch_h;++f)
{
    *scrptr= ((*scrptr)&(mask^0xff))|(cdatalow&mask);
    scrptr+=20;
    cdatalow= (cdatalow>>4) | (cdatahigh<<28);
    cdatahigh>>=4;
}


}


void putc_orig(int c)
{
    putcon(c);
    ++__mg->__console_vars->__pos_x;
    if(__mg->__console_vars->__pos_x>=__mg->__console_vars->__scr_w) {
        __mg->__console_vars->__pos_x= 0;
        ++__mg->__console_vars->__pos_y;
        if(__mg->__console_vars->__pos_y>=__mg->__console_vars->__scr_h) { scroll(); --__mg->__console_vars->__pos_y; }
    }
}

int dummy_putchar(int c)
{
return c;
}


int putchar_orig(int c)
{

if(c<5||c>=17) putc_orig(c);

switch(c)
{
case 5:
    clreol_orig(); // < ibl ; 2004-10-28 >
    return c;
case 7:
    //beep();
    return c;
case 8:
    --__mg->__console_vars->__pos_x;
    if(__mg->__console_vars->__pos_x<0) { __mg->__console_vars->__pos_x=__mg->__console_vars->__scr_w; if(__mg->__console_vars->__pos_y>0) __mg->__console_vars->__pos_y--;  }
    putcon(c);
    return c;
case 9:
    // TRAP: works for TABSIZE being a power of 2 only! 
    // < ibl ; 2005-05-17 >
    {
        int t = __mg->__console_vars->__pos_x & (_TAB_SIZE-1);
        if (!t)
            t = _TAB_SIZE;
        // No NULL tab steps!
        //  < ibl ; 2005-05-17 >
        while(t--) putc_orig(32);
        return c;
    }
case 10:
    ++__mg->__console_vars->__pos_y;
    if(__mg->__console_vars->__auto_cr) __mg->__console_vars->__pos_x= 0;
    if(__mg->__console_vars->__pos_y>=__mg->__console_vars->__scr_h) { scroll(); --__mg->__console_vars->__pos_y; }
    return c;
case 11:
    putc_orig(c);
    return c;
case 12:
    clear_screen();
    __mg->__console_vars->__pos_y=__mg->__console_vars->__pos_x=0;
    return c;
case 13:
    __mg->__console_vars->__pos_x=0;
    return c;
/*
case 14:
    // siso ???
    return c;
case 15:
    // ul -> underlined?
    return c;
case 16:
    // smooth ???
    return c;
*/

    
}

return c;    
}


void dummy_clear_screen(void)
{
	return;
}



void clear_screen(void)
{
	(*(__console[__mg->__console_type].clear_screen))();
}



int
putchar(int c)
{
    return (*(__console[__mg->__console_type].putchar))(c);
}

